/*
 * cocos2d for iPhone: http://www.cocos2d-iphone.org
 *
 * Copyright (c) 2011 Ricardo Quesada
 * Copyright (c) 2012 Zynga Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 coc_1;
uniform vec2 coc_2;

uniform float radius_1;
uniform float radius_2;

uniform float offset;


float circle(vec2 pos, vec2 center, float radius) {
    float dist = length(pos - center) - radius;
    
    float dd = dist/radius;
    float t = smoothstep(0.0, 1.2, 1.0 - pow(dd, 1.0));
    return t;
}

float getAlpha(float r,vec2 center,vec2 pos,float offset){
    if (r != 0.0) {
        r = r - sin(CC_Time[2]) * offset;
        return circle(pos,center,r);
    }
    return 0.0;
}

void main()
{
    vec4 c = v_fragmentColor;
    
    vec2 pos = vec2(gl_FragCoord.x * 1.0,gl_FragCoord.y * 1.0);

    float a1 = 0.9 - getAlpha(radius_1,coc_1,pos,offset);
    float a2 = 0.9 - getAlpha(radius_2,coc_2,pos,offset);
    c.a = a1 * a2;
    gl_FragColor = c;
}