#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float fPercentR;
uniform float fPercentG;
uniform float fPercentB;
uniform float fEnhance;

void main()
{
    vec4 c = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);

    float cr = 0.3 * fEnhance;
    float cg = 0.2 * fEnhance;
    float cb = 0.2 * fEnhance;
    vec3 cNew = vec3(cr,cg,cb);

    float gray = dot(c.rgb, cNew);

    float crp = fPercentR;
    float cgp = fPercentG;
    float cbp = fPercentB;

    gl_FragColor = vec4(gray * (1.0 - crp)  + c.r * crp, gray * (1.0 - cgp)  + c.g * cgp, gray * (1.0 - cbp)  + c.b * cbp, c.a);
}